<?php

class Cola_Com_SmsClient
{    
    var $version = 1;
    var $format = 'json';
    
    private $host = 'http://sms-api.63810.com';
    
    var $methods = array(
            'getUserInfo',
            'sms_send',
            'register',
            'get_info',
            'changePassword',
            'smsHistory',
            'replySms'
    );
    var $products = array(
            'notify' => '通知/会员类通道',
            'ad' => '106广告类通道',
            'adcard' => '卡发广告类通道',
            'adfangchan'=> '106房产专用通道',
            'dxztd' => '低限制通道'
    );

    
    /*****************************/
    
    private function _request($method, $data = array(), $server = 'Client')
    {
        if (false == in_array($method, $this->methods))
        {
            return -1;
        }
        $url = $this->host . '/'. $server .'/' . $method;
        
        $response = Cola_Com_Http::post($url, $data);

        return $this->format=='json' ? json_decode($response, true) : $response;
    }
    
    private function _getHash()
    {
        static $hash;
        if ($hash)
        {
            return $hash;
        }
        $u = self::who();
        
        $hash = md5($u['username'] . ":" . $u['password']);
        return $hash;
    }
    
    
    /* public function  */
    
    function getProductName($key)
    {
        return isset($this->products[$key]) ? $this->products[$key] : false;
    }
    
    function isLogin()
    {
        return isset($_SESSION['user']);
    }
    
    function who()
    {
        return @$_SESSION['user'];
    }
    
    function logout()
    {
        unset($_SESSION['user']);
    }
    
    function getUserProduct()
    {
        return $_SESSION['products'];
    }
    
    function login($username, $password, &$error  = null)
    {
        $password = md5($password);
        $post_data = compact('username', 'password');
        
        $data = self::_request('getUserInfo', $post_data);

        if (!$data['result']) {
            $error = $data['msg'];
        }
        else {
            $_SESSION['user'] = $data['data'] + $post_data;
        }
        
        $productInfo = $this->getInfo();
        $_SESSION['products'] = $productInfo;
    }
    
    function changePassword($new_password, &$error)
    {
        $u = $this->who();
        extract($u);
        $post_data = compact('username', 'password', 'new_password');
        
        $rs = self::_request('changePassword', $post_data);
        
        if (!$rs['result']) {
            $error = $rs['msg'];
        }
    }
    
    function register($pass = array(), &$error = null)
    {
        $account = Cola::getInstance()->config('account');
        $account['password'] = md5($account['password']); 

        $account['data'] = $pass;
        $data = self::_request('register', $account);

        if (!$data['result']) {
            $error = $data['msg'];
        }
        
        return $data['result'];
    }
    
    function getInfo(&$error = null)
    {
        $u = $this->who();
        $post = array('hash' => $this->_getHash(), 'user' => $u['username']);
        $data = self::_request('get_info', $post, 'api');
        
        if (!$data['result']) {
            $error = $data['msg'];
        }
        return $data['data'];
    }
    
    function getHistory($p = 0, $n = 25, &$error = null)
    {
        $u = $this->who();
        extract($u);
        $post_data = compact('username', 'password');
        $post_data['page'] = $p;
        $post_data['length'] = $n;
        
        $rs = self::_request('smsHistory', $post_data);

        if (!$rs['result']) {
            $error = $rs['msg'];
        }

        return $rs['data'];
    }
    
    function getReplySms($p = 0, $n = 25, &$error = null)
    {
        $u = $this->who();
        extract($u);
        $post_data = compact('username', 'password');
        $post_data['page'] = $p;
        $post_data['length'] = $n;
        
        $rs = self::_request('replySms', $post_data);
        
        if (!$rs['result']) {
            $error = $rs['msg'];
        }
        
        return $rs['data'];
    }
    
    function send($product, $mobiles, $msg)
    {
        $u = $this->who();
        $post_data = array(
                    'hash' => $this->_getHash(),
                    'user' => $u['username'],
                    'encode' => 'utf-8',
                    'smstype' => $product,
                    'content' => $msg,
                    'mobile' => $mobiles
                );
        $data = self::_request('sms_send', $post_data, 'api');
        return $data;
    }
}