<?php

require_once 'AppController.php';

class SmsController extends AppController
{
    public function sendAction()
    {
        if (($post = $this->form()))
        {
            $this->view->form = $post;
            
            $rules = array(
                    'mobiles' => array('required' => 1, 'msg' => '手机号不能为空。'),
                    'msg'  => array('required' => 1, 'msg' => '短信内容不能为空。'),
            );
            $validate = $this->com->validate;
            
            if (!$validate->check($post, $rules, true))
            {
                $error = $validate->error();
                $this->view->error = $error;
            }
            else
            {
                $rs = $this->SmsClient->send($post['product'], $post['mobiles'], $post['msg']);
                if ($rs['result'])
                {
                    $this->setFlash('短信已经发送');
                    $url = $this->url("sms", "send", array('p'=>$post['product']));
                    $this->redirect($url);
                }
                $this->setFlash($rs['msg']);
            }
        }
        $msg = $this->getFlash();
        $this->view->msg = $msg;
        
        $p = $this->get('p', 0);
        $this->view->p = $p;
        
        $product = $this->SmsClient->getUserProduct();
        foreach ($product['sms'] as $one) {
            if ($one['name'] == $p) {
                $this->view->number = $one['number'];
                break;
            }
        }
        
        $this->view->product = $this->SmsClient->getProductName($p);
        $this->display();
    }
    
    function historyAction() {
        $p = (int)$this->get('page') ? (int)$this->get('page') : 1;
        $data = $this->SmsClient->getHistory($p, 25, $error);
        if ($error) {
            $this->response->alert($error);
        }
        else {
            $this->view->list = $data['items'];
            
            if ($data['page']['prevPage']) {
                $this->view->perv_page = $p-1;
            }
            if ($data['page']['nextPage']) {
                $this->view->next_page = $p+1;
            }
            $this->view->count = $data['page']['count'];
        }
        
        $this->display();
    }
    
    function replyAction() {
        $p = (int)$this->get('page') ? (int)$this->get('page') : 1;
        $data = $this->SmsClient->getReplySms($p, 25, $error);
        if ($error) {
            $this->response->alert($error);
        }
        else {
            $this->view->list = $data['items'];
        
            if ($data['page']['prevPage']) {
                $this->view->perv_page = $p-1;
            }
            if ($data['page']['nextPage']) {
                $this->view->next_page = $p+1;
            }
            $this->view->count = $data['page']['count'];
        }
        
        $this->display();
    }
}