<?php

require_once 'AppController.php';

class UserController extends AppController
{
    public function registerAction()
    {
        $vals = $this->form();
        if ($vals) {
            $error = null;
            $rules = array(
                    'username' => array('required' => 1, 'msg' => '用户名不能为空。'),
                    'password' => array('required' => 1, 'msg' => '密码不能为空。'),
                    'email' => array('type'=>'email', 'msg' => '邮箱不正确'),
                    'qq' => array('required' => 1, 'type'=>'number', 'msg' => 'QQ号不正确')
            );
            $validate = $this->com->validate;
            if (!$validate->check($vals, $rules, true)) {
                $error = $validate->error();
                $error = pos($error);
            }
            if ($vals['password'] != $vals['cpassword']) {
                $this->response->alert("两次输入的密码不同。");
            }
            if (!$error) {
                $this->com->SmsClient->register($vals, $error);
            }
            if (!$error) {
                $this->redirect('/');
            }

            $this->response->alert($error);

            unset($vals['passwords']);
            unset($vals['c_passwords']);

            $this->view->form = $vals;
        }
        $this->display();
    }

    public function loginAction()
    {
        $this->com->SmsClient->logout();

        $vals = $this->form();
        if ($vals) {
            extract($vals);
            $this->com->SmsClient->login($user, $pass, $error);
            if ($error) {
                $this->response->alert($error);
            }
            else {
                $this->redirect('/');
            }
        }

        $this->display();
    }

    public function logoutAction()
    {
        $this->com->SmsClient->logout();
        session_destroy();
        $this->redirect('/');
    }


    public function passwordAction()
    {
        $here = $this->url('user','password');
        
        if (($post = $this->form()))
        {
            $u = $this->SmsClient->who();
            if ($u['password'] != md5($post['password'])) {
                $this->response->alert("密码不正确", $here);
            }
            elseif (strlen($post['new_password']) < 6) {
                $this->response->alert("新密码最少6位", $here);
            }
            elseif ($post['c_new_password']!=$post['new_password']) {
                $this->response->alert("两次输入的密码不同", $here);
            }
            else {
                $this->SmsClient->changePassword($post['new_password'], $error);
                if ($error) {
                    $this->response->alert($error, $here);
                }
                else {
                    $this->response->alert("密码已修改", $this->url('user','logout'));
                }
            }
        }
        $this->display();
    }
}